<?php

// Updated June17, 2008 by Veronica for support of PHP Fusion v6.01.12 and later
// added also support for PM Photos via PHP Fusion avatars

// Updated June 27, 2008 for PHP Fusion version 7.00 RC2
// 
// Main difference to older fusionCMS scripts for FlashChat integrations:
// support for user groups in PHP Fusion
// use of COOKIE_PREFIX, DB_USERS from Fusion multisite_include.php
// Fusion user_status == 1 banned both in Forum and in chat
// direct login to FlashChat will set the Fusion user cookie for 3 hours
 
if(!defined('INC_DIR')) die('hacking attempt');

$fusion_root_path = realpath(dirname(__FILE__) . '/../../../') . '/';
include_once($fusion_root_path . 'config.php');
include_once($fusion_root_path . 'includes/multisite_include.php');

class FusionCMS {

    var $userid;
    var $loginStmt;
    var $getUserStmt;
    var $getUsersStmt;

// Chat owner configuration options:

	var $cookie_time = 3;			// number of hours lifetime for cookie being set during direct FlashChat login

// Default FlashChat users 
   
    var $user_level_101  = 101;		// PHP Fusion user level 101 is a FlashChat User
    var $user_level_102  = 102;		// PHP Fusion user level 102 is a FlashChat Moderator
    var $user_level_103  = 103;		// PHP Fusion user level 103 is a FlashChat Administrator

// Define user groups to override above User Levels
// enter a list of user group numbers (group_id) separated by commas
// examples:
//  var $group_moderator = array(3,7); 
//  var $group_moderator = array(8); 

    var $group_admin 	 = array();		
    var $group_moderator = array();	
    var $group_user 	 = array();
    var $group_banned 	 = array();		// allowed in Forum but banned for chat login

// End of configuration    

    function FusionCMS() {

		$this->loginStmt = new Statement("SELECT user_id AS id, user_status FROM " . DB_USERS . " WHERE user_name=? AND (user_password=? OR user_password=?) LIMIT 1");
		$this->getUserStmt = new Statement("SELECT user_id AS id, user_name AS login, user_status, user_groups, user_level, user_avatar FROM " . DB_USERS . " WHERE user_id=? LIMIT 1");
		$this->getUsersStmt = new Statement("SELECT user_id AS id, user_name as login FROM " . DB_USERS);

		$this->userid = NULL;

		if(isset($_COOKIE[COOKIE_PREFIX . 'user'])) {
			$cookie_vars = explode(".", $_COOKIE[COOKIE_PREFIX . 'user']);
			$cookie_1 = is_numeric($cookie_vars['0']) ? $cookie_vars['0'] : NULL;
			$this->userid = $cookie_1;
		}
    }

    function isLoggedIn() {
        return $this->userid;
    }

    function getRoles($user_level, $user_groups) {
    
        $rv = ROLE_ANY;

        if($user_level == $this->user_level_101) {
			$rv = ROLE_USER;
        	if($GLOBALS['fc_config']['liveSupportMode']) $rv = ROLE_CUSTOMER;
        }
        if($user_level == $this->user_level_102) $rv = ROLE_MODERATOR;
        if($user_level == $this->user_level_103) $rv = ROLE_ADMIN;
       
        if($user_groups != '') {
			$groups = explode('.', substr($user_groups, 1));
			foreach($groups as $k => $v) {
				if(in_array($v, $this->group_user)) 	  $rv = ROLE_USER;
				if(in_array($v, $this->group_moderator))  $rv = ROLE_MODERATOR;
				if(in_array($v, $this->group_admin)) 	  $rv = ROLE_ADMIN;
				if(in_array($v, $this->group_banned)) 	  $rv = ROLE_NOBODY;
			}
		}
        return $rv;
    }

    function getUserProfile($userid) {

        $rv = '';
        if($userid == SPY_USERID) $rv = NULL;
        elseif($user = $this->getUser($userid)) {

          $rv = ($this->userid == $userid) ?  "../edit_profile.php" : "../profile.php?lookup=" . $userid;
        }
        return $rv;
    }

    function getUser($userid) {

      $rv = NULL;

      if(($rs = $this->getUserStmt->process($userid)) && ($rec = $rs->next())) {
        $rec['roles'] = $this->getRoles($rec['user_level'], $rec['user_groups']);
        if($rec['user_status'] == 1) $rec['roles'] = ROLE_NOBODY;
        $rv = $rec;
      }
      return $rv;
    }
    
	function stripinput($text) {
		 
		if(ini_get('magic_quotes_gpc')) $text = stripslashes($text);
		$search = array("\"", "'", "\\", '\"', "\'", "<", ">", "&nbsp;");
		$replace = array("&quot;", "&#39;", "&#92;", "&quot;", "&#39;", "&lt;", "&gt;", " ");
		return str_replace($search, $replace, $text);
	}

    function login($login, $password) {

		$md5pwd = md5($password);
		$user_name = preg_replace(array("/\=/","/\#/","/\sOR\s/"), "", $this->stripinput($login));

      	if(($rs = $this->loginStmt->process($user_name, md5($md5pwd), $md5pwd)) && ($rec = $rs->next())) {

       		if($rec['user_status'] == 0) setcookie(COOKIE_PREFIX . "user", $rec['id'] . "." . $md5pwd, time() + $this->cookie_time * 3600, "/", "", "0");
        	return $rec['id'];
      	}
      	return null;
    }

	function userInRole($userid, $role) {
		if($user = $this->getUser($userid)) {
			return ($user['roles'] == $role);
		}
		return false;
	}

    function logout() {

    }

    function getUsers() {

        $rv = $this->getUsersStmt->process();
        return $rv;
    }

	function getGender($userid) {
        // 'M' for Male, 'F' for Female, NULL for undefined
        return NULL;
    }
    
    function getPhoto($userid) {
     
		$user = $this->getUser($userid);
		if($user == null) return '';
		if($user['user_avatar'] != '') {
			if(!strpos(strtolower($user['user_avatar']), '.jpg')) return '';
			if(file_exists('../images/avatars/' . $user['user_avatar'])) return '../images/avatars/' . $user['user_avatar'];
		}
		return '';
	}
}

$GLOBALS['fc_config']['db'] = array(
    'host' => $GLOBALS['db_host'],
    'user' => $GLOBALS['db_user'],
    'pass' => $GLOBALS['db_pass'],
    'base' => $GLOBALS['db_name'],
    'pref' => DB_PREFIX . "fc_"
    );

$GLOBALS['fc_config']['cms'] = new FusionCMS();


foreach($GLOBALS['fc_config']['languages'] as $k => $v) {
    $GLOBALS['fc_config']['languages'][$k]['dialog']['login']['moderator'] = '';
}

?>